#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <malloc.h>
#include <ctype.h>

//     
int validateInput(const char* input) {
    for (int i = 0; input[i] != '\0'; i++) {
        if (!isdigit(input[i])) {
            return 0; //  
        }
    }
    return 1;
}

//    
DWORD WINAPI factorialFunc(LPVOID arg) {
    char* input = (char*)arg;

    //  
    if (!validateInput(input)) {
        printf(":   !\n");
        free(input); //  
        return 1;
    }

    int n = atoi(input);
    free(input); //    

    if (n < 0) {
        printf(":     !\n");
        return 1;
    }

    long long fact = 1;
    for (int i = 1; i <= n; i++) {
        fact *= i;
    }

    printf("  %d  %lld\n", n, fact);
    return 0;
}

int main() {

    system("chcp 1251 > null");

    HANDLE hThread;
    DWORD threadId;
    char input[100];

    printf(" : ");
    scanf("%s", input);

    //       
    char* inputCopy = (char*)malloc(strlen(input) + 1);
    if (inputCopy == NULL) {
        fprintf(stderr, ":    !\n");
        return 1;
    }
    strcpy(inputCopy, input);

    //  
    hThread = CreateThread(
        NULL,               //  
        0,                  //  
        factorialFunc,      //  
        inputCopy,          //   
        0,                  //  
        &threadId           // ID 
    );

    if (hThread == NULL) {
        printf(":    !\n");
        free(inputCopy); //  ,     
        return 1;
    }

    //   
    WaitForSingleObject(hThread, INFINITE);

    //   
    CloseHandle(hThread);

    return 0;
}